import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Dimension;
import java.awt.Color;
/**
 * Write a description of class Block here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Block implements GameObject, Drawable, ColisionObject
{
    private Vertex3D _myPosition;
    private Dimension _mySize;
    private BoxColider _myColider;

    public Block(int x,int y,int width, int height)
    {
        _myPosition = new Vertex3D(x,y);
        _mySize     = new Dimension(width,height);
        _myColider  = new BoxColider(x,y,width,height);
    }

    public void draw(Graphics2D g)
    {
        g.setColor(Color.blue);
        g.fillRect((int)_myPosition.getX(),(int)_myPosition.getYConv(),
            (int)_mySize.getWidth(),(int)_mySize.getHeight());
    }

    public Point getPosition()
    {
        return _myPosition.toPoint();
    }
    
    public boolean isColiding(Vertex3D position)
    {
        return _myColider.isColiding(position);
    }

    public void update()
    {

    }
}
