import java.lang.Runnable;
import java.util.Random;

/**
 * Write a description of class Game here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Game implements Runnable
{
    // instance variables - replace the example below with your own
    private GameObjects gobj;
    private GameWindow  gwdw;
    private Thread updateThread;
    private Thread inputThread;
    private Input input;
    
    
    public Game()
    {
        // Initialize GameWindow and Objects
        gobj = new GameObjects();
        gwdw = new GameWindow(gobj);
        input = new Input();
        
        gwdw.addKeyListener(input);
        
        // Create Player
        Player plyr = new Player(input,gobj);
        gobj.add(plyr);
        
        // Create Other Objects
        Block blk = new Block(0,20,1280,20);
        gobj.add(blk);
        blk = new Block(200,100,150,20);
        gobj.add(blk);
        blk = new Block(400,180,150,20);
        gobj.add(blk);
        blk = new Block(600,260,150,20);
        gobj.add(blk);
        blk = new Block(400,340,150,20);
        gobj.add(blk);
        blk = new Block(200,420,150,20);
        gobj.add(blk);
        blk = new Block(400,500,150,20);
        gobj.add(blk);
        blk = new Block(800,340,150,20);
        gobj.add(blk);
        blk = new Block(1000,420,150,20);
        gobj.add(blk);
        
        Random rng = new Random();
        
        blk = new Block(rng.nextInt() % 1000,420,150,20);
        gobj.add(blk);
        
        // Create Threads
        updateThread = new Thread(this);
        
        // Start Threads
        updateThread.start();
        
        // Entering GraphicLoop
        graphicLoop();
    }
    
    public void graphicLoop()
    {
        while(true)
        {
            long start = System.nanoTime();
            gwdw.repaint();
            long sleep = (System.nanoTime()-start)/1000000; // Millis
            try
            {
                Thread.sleep(40-sleep); // Limit to 25 FPS
            }
            catch(InterruptedException e)
            {
                // Interrupt
                System.err.println("Can't Keep Up");
            }
        }
    }
    
    public void run()
    {
        while(true)
        {
            long start = System.nanoTime();
            gobj.update();
            long sleep = (System.nanoTime()-start)/1000000; // Millis
            try
            {
                Thread.sleep(25-sleep); // 40 Updates per Second
            }
            catch(InterruptedException e)
            {
                // Interrupt
                System.err.println("Can't Keep Up");
            }
        }
    }

    public static void main(String[] args) 
    {
        Game mainGame = new Game();
    }
}
