import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Color;
import java.awt.event.*;
/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player implements GameObject, Drawable, ColisionObject
{
    private GameObjects _gobjHandle;
    private Vertex3D _myPosition;
    private Input _myInput;
    private SimpleNewton _physic;
    private short _jumpCounter;
    
    
    public Player(Input GameInput,GameObjects gobjhandle)
    {
        _myPosition = new Vertex3D(50,50);
        _myInput = GameInput;
        _gobjHandle = gobjhandle;
        _physic = new SimpleNewton(_myPosition,gobjhandle);
        _jumpCounter = 0;        
    }
    
    public void update()
    {
        _physic.update();
        if(_myInput.isKeyPressed(KeyEvent.VK_W))
        {
            if(_physic.getYAcceleration() < -9 && _jumpCounter<2 && _physic.getYVelocity() <=0)
            {
                _physic.giveYAcceleration(+45.0);
                _jumpCounter++;
            }
        }
        if(_myInput.isKeyPressed(KeyEvent.VK_A))
        {
            _myPosition.decX(5);
        }
        if(_myInput.isKeyPressed(KeyEvent.VK_D))
        {
            _myPosition.incX(5);
        }
        checkBounds();
        if(_jumpCounter>0 && _physic.isOnGround())
        {
            _jumpCounter = 0;
        }
    }
    
    private void checkBounds()
    {
        if(_myPosition.getX()>1265)
        {
            _myPosition.setX(1265);
        }
        else if(_myPosition.getX()<0)
        {
            _myPosition.setX(0);
        }
        if(_myPosition.getY()>700)
        {
            _myPosition.setY(700);
        }
        else if(_myPosition.getY()<40)
        {
            _myPosition.setY(40);
        }
    }
    
    public Point getPosition()
    {
       return _myPosition.toPoint();
    }
    
    public boolean isColiding(Vertex3D position)
    {
        return false;
    }
    
    public void draw(Graphics2D g)
    {
        Point drawPosition = _myPosition.toPoint();
        g.setColor(Color.red);
        g.fillOval((int)drawPosition.getX(),(int)drawPosition.getY(),15,20);
    }
}
