
/**
 * Write a description of class SimpleNewton here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SimpleNewton
{
    // instance variables - replace the example below with your own
    private Vertex3D _objectPosition;
    private double _accelerationX;
    private double _accelerationY;
    private double _accelerationZ;
    private double _gravitation = 9.80665; // m/s^2
    private double _velocityX;
    private double _velocityY;
    private double _velocityZ;
    private GameObjects _gobjHandle;
    private boolean _onGround;

    public SimpleNewton(Vertex3D objectPosition, GameObjects gobjhandle)
    {
        // Bind objectPosition to _objectPosition. For better Performance we need
        // the reference of the Object not an Cloned Object
        _objectPosition = objectPosition;
        _accelerationX = 0;
        _accelerationY = 0;
        _accelerationZ = 0;
        _velocityX     = 0;
        _velocityY     = 0;
        _velocityZ     = 0;
        _gobjHandle = gobjhandle;
    }

    /**
     * Do a physics tick
     */
    public void update()
    {
        this.gravitation();
    }
    
    public boolean isOnGround()
    {
        return _onGround;
    }

    private void gravitation()
    {
        System.out.println(_velocityY+" | "+_accelerationY);

        if(_velocityY > -150)
        {
            _velocityY += 0.25 * _accelerationY;
        }
        
        if( !(_gobjHandle.isColiding(new Vertex3D(_objectPosition.getX(),
           _objectPosition.getY()+0.25 * _velocityY))))
        {
            _onGround = false;
            _objectPosition.incY(0.25 * _velocityY);
        }
        else {
            _velocityY = 0;
            _onGround = true;
        }

        // Limit Falling acceleration to max Gravitation
        if(_accelerationY>(-_gravitation))
        {
            _accelerationY -=0.50 * _gravitation;
        }
        else 
        {
            _accelerationY = -_gravitation;
        }
    }

    public void giveXAcceleration(double acceleration)
    {
        _accelerationX += acceleration;
    }

    public void giveYAcceleration(double acceleration)
    {
        _accelerationY += acceleration;
        _velocityY = 0;
    }

    public void giveZAcceleration(double acceleration)
    {
        _accelerationZ += acceleration;
    }

    public void giveAcceleration(double degree, double acceleration)
    {
        // Some Black Magic
    }

    public double getXAcceleration()
    {
        return _accelerationX;
    }

    public double getYAcceleration()
    {
        return _accelerationY;
    }

    public double getZAcceleration()
    {
        return _accelerationZ;
    }

    public double getXVelocity()
    {
        return _velocityX;
    }

    public double getYVelocity()
    {
        return _velocityY;
    }

    public double getZVelocity()
    {
        return _velocityZ;
    }
}
